TwitterRealID = {}

--[[
-----------------------------------------------
TODO

Add an X button to close the log.
Track messaging per toon in addition to account.
	I want a per char log for own toons and a log for log data shared from other people. There will be three logs after these are implemented - all at the account level.
	The current per char log needs to be modified.
-----------------------------------------------

-----------------------------------------------
KNOWN ISSUES

* = tracking issue

Normal dungeons entered are not reported against - add a check box for it.
*TRID reports encounter engaged at end of combat sometimes.
	This is disabled for now
-----------------------------------------------
--]]


---------------------------
-- Control variables
local currentVersion = 3.1
local release = true
---------------------------


TRID_DB = {}
TRID_DB_PER_CHAR = {}
--This variable is for auto grats to track time elapsed in the cycle function
local gratsTimeElapsed = 0
--Condition for auto grats (in seconds)
local gratsTime = 5
local doGrats = false
local achievementEarner = ""
local earnerCount = 0

local frame = CreateFrame("Frame", "TwitterRealIDMain", UIParent)
frame.name = "TRID"
InterfaceOptions_AddCategory(frame)

--Set up a couple of slash commands.
SLASH_TRIDTOGGLE1 = "/trid"
SlashCmdList["TRIDTOGGLE"] = function(var)
	var = string.upper(var)
	if var == "ON" then
		TwitterRealID:Toggle(true)
		--Will only trigger if zone messages are on.
		TwitterRealID:SendCurrentMessage("worldState")
		DEFAULT_CHAT_FRAME:AddMessage("TRID is now ON", 0, 1, 0.5)
	elseif var == "OFF" then
		TwitterRealID:Toggle(false)
		DEFAULT_CHAT_FRAME:AddMessage("TRID is now OFF", 0, 1, 0.5)
	elseif var == "CLEAR" then
		--clear the message
		TwitterRealID:SendCurrentMessage("clear")
		DEFAULT_CHAT_FRAME:AddMessage("<TRID> Broadcast message cleared", 0, 1, 0.5)
--[[
	elseif var == "GUILD" then
		--toggle sending of messages to guild chat
		if TRID_DB.sendToGuild then
			TRID_DB.sendToGuild = false
			DEFAULT_CHAT_FRAME:AddMessage("TRID is no longer broadcasting to guild chat", 0, 1, 0.5)
		else
			TRID_DB.sendToGuild = true
			DEFAULT_CHAT_FRAME:AddMessage("TRID is now broadcasting to guild chat", 0, 1, 0.5)
		end
--]]
	elseif var == "INFO" then

		local tridStatus = "OFF"
		if TRID_DB.toggleStatus then
			tridStatus = "ON"
		else
			tridStatus = "OFF"
		end
		DEFAULT_CHAT_FRAME:AddMessage("TRID is currently "..tridStatus, 0, 1, 0.5)
	elseif var == "UI" or var == "OPTIONS" then
		InterfaceOptionsFrame_OpenToCategory(frame)
	elseif var == "T" or var == "LOG" then
		if frame.log:IsVisible() then
			frame.log:Hide()
		else
			frame.log:Show()
		end
	else
		print("TwitterRealID Commands:\n"
		.."|cFF00FFFF/trid ui|r - Opens the TRID UI\n"
		.."|cFF00FFFF/trid log|r - Opens your log\n"
		.."|cFF00FFFF/trid info|r - Provides TRID status info\n"
		.."|cFF00FFFF/trid clear|r - Clear the current message\n"
		.."|cFF00FFFF/trid on|r - Turns on TwitterRealID\n"
		.."|cFF00FFFF/trid off|r - Turns off TwitterRealID")
	end
end


--Register the events we're going to use.
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
--frame:RegisterEvent("PLAYER_REGEN_DISABLED")
--frame:RegisterEvent("PLAYER_REGEN_ENABLED")
--frame:RegisterEvent("INSTANCE_ENCOUNTER_ENGAGE_UNIT")
frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
frame:RegisterEvent("UPDATE_BATTLEFIELD_STATUS")
frame:RegisterEvent("ACHIEVEMENT_EARNED")
frame:RegisterEvent("CHAT_MSG_LOOT")
frame:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")
frame:RegisterEvent("CHAT_MSG_ADDON")

--Handle events
frame:SetScript("OnEvent", function(self, event, ...)
	if event == "ADDON_LOADED" then
		local name = ...
		if name == "TwitterRealID" then
			TwitterRealID:Init()
		end
	--[[
	elseif event == "PLAYER_REGEN_DISABLED" then
		TwitterRealID:SendCurrentMessage("bossFight")
	--]]
	----[[
	elseif event == "ZONE_CHANGED_NEW_AREA" then
		TwitterRealID:SendCurrentMessage("worldState")
	--[[
	elseif event == "INSTANCE_ENCOUNTER_ENGAGE_UNIT" then
		TwitterRealID:SendCurrentMessage("bossFight")
	--]]
	elseif event == "COMBAT_LOG_EVENT_UNFILTERED" then
		timestamp, subEvent, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName = ...
		if subEvent == "UNIT_DIED" then
			TwitterRealID:SendCurrentMessage("bossKill", destName, destGUID)
		end
	elseif event == "UPDATE_BATTLEFIELD_STATUS" then
		TwitterRealID:SendCurrentMessage("bgEnd")
	elseif event == "ACHIEVEMENT_EARNED" then
		local achievementID = ...
		local id, name, points = GetAchievementInfo(achievementID)
		local link = GetAchievementLink(achievementID)
		TwitterRealID:SendCurrentMessage("achievement", name, points, link)
	elseif event == "CHAT_MSG_LOOT" then
		local message, sender, language, channelString, target, flags = ...
		if string.find(message, "You receive loot:") ~= nil and sender == "" then
			--Rip the link out of the string and make sure the period at the end is off of it
			local link = string.sub(message, 19, string.len(message) - 1)
			TwitterRealID:SendCurrentMessage("loot", link)
		end
	elseif event == "CHAT_MSG_GUILD_ACHIEVEMENT" then
		local message, sender = ...
		TwitterRealID:SendCurrentMessage("guildGrats", sender)
	elseif event == "CHAT_MSG_ADDON" then
--~ 		local prefix = ...
--~ 		tridprint(prefix)
	end
end)

---------------------------
--Set up the addon on load
---------------------------
function TwitterRealID:Init()
	DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF<TRID>|r loaded. Type |cFF00FFFF/trid|r to access options. \nTRID now tracks a history of your messages! Access it with |cFF00FFFF/trid log|r.", 0.5, 1, 1)

	--The message log
	TRID_DB.log = TRID_DB.log or {}
	TRID_DB_PER_CHAR.log = TRID_DB_PER_CHAR.log or {}

	frame.log = TwitterRealID:SetupLog()
	table.insert(UISpecialFrames,"LogFrame")


	--Tracks the number of messages in the log.  If the player got more than 100 messages recorded in one minute, this could be a problem --unlikely.
	TRID_DB.messageCounter = TRID_DB.messageCounter or 101

	--Get the time. Should only do GetRealmTime on first use.
	TRID_DB.time = TRID_DB.time or TwitterRealID:GetRealmTime()

	--Let's set up some defaults here.  Only do this if the data is old or hasn't ever been set up.
	--Should only ever be 0 the first time.  currentVersion needs to be updated with various releases.
	TRID_DB.version = TRID_DB.version or 0
	if TRID_DB.version == nil or TRID_DB.version == 0 then
		--Opens to the addon pane on load if there's been an update or this is the first time using the addon
		InterfaceOptionsFrame_OpenToCategory(frame)
		--Set up defaults
		TRID_DB.customWorldMessage = "Travelling the world."
		TRID_DB.currentIsWinMessage = false
		TRID_DB.messageIsInstance = false
		TRID_DB.toggleStatus = true
		TRID_DB.version = currentVersion
		--BN options
		TRID_DB["lootFrame"] = 1
		TRID_DB["achievementFrame"] = 1
		TRID_DB["bgEnteredFrame"] = 1
		TRID_DB["bgWonFrame"] = 1
		TRID_DB["raidEnteredFrame"] = 1
		TRID_DB["raidKillFrame"] = 0
		TRID_DB["heroicEnteredFrame"] = 0
		TRID_DB["heroicKillFrame"] = 0
		TRID_DB["zoneFrame"] = 0
		--Guild options
		TRID_DB["lootFrame1"] = 1
		TRID_DB["achievementFrame1"] = 0
		TRID_DB["bgEnteredFrame1"] = 1
		TRID_DB["bgWonFrame1"] = 1
		TRID_DB["raidEnteredFrame1"] = 1
		TRID_DB["raidKillFrame1"] = 0
		TRID_DB["heroicKillFrame1"] = 0
		TRID_DB["heroicEnteredFrame1"] = 0
		TRID_DB["zoneFrame1"] = 0
		TRID_DB["guildGratsFrame1"] = 0
	elseif TRID_DB.version < currentVersion then
		--Opens to the addon pane on load if there's been an update.
		InterfaceOptionsFrame_OpenToCategory(frame)
		--Use existing variables if they are there. Can force reset of defaults between versions in this chunk if needed.
		TRID_DB.customWorldMessage = TRID_DB.customWorldMessage or "Travelling the world."
		TRID_DB.currentIsWinMessage = TRID_DB.currentIsWinMessage or false
		TRID_DB.messageIsInstance = TRID_DB.messageIsInstance or false
		TRID_DB.toggleStatus = TRID_DB.toggleStatus or true
		TRID_DB.version = currentVersion
		--BN options
		TRID_DB["lootFrame"] = TRID_DB["lootFrame"] or 1
		TRID_DB["achievementFrame"] = TRID_DB["achievementFrame"] or 1
		TRID_DB["bgEnteredFrame"] = TRID_DB["bgEnteredFrame"] or 1
		TRID_DB["bgWonFrame"] = TRID_DB["bgWonFrame"] or 1
		TRID_DB["raidEnteredFrame"] = TRID_DB["raidEnteredFrame"] or 1
		TRID_DB["raidKillFrame"] = TRID_DB["raidKillFrame"] or 0
		TRID_DB["heroicEnteredFrame"] = TRID_DB["heroicEnteredFrame"] or 0
		TRID_DB["heroicKillFrame"] = TRID_DB["heroicKillFrame"] or 0
		TRID_DB["zoneFrame"] = TRID_DB["zoneFrame"] or 0
		--Guild options
		TRID_DB["lootFrame1"] = TRID_DB["lootFrame1"] or 1
		TRID_DB["achievementFrame1"] = TRID_DB["achievementFrame1"] or 0
		TRID_DB["bgEnteredFrame1"] = TRID_DB["bgEnteredFrame1"] or 1
		TRID_DB["bgWonFrame1"] = TRID_DB["bgWonFrame1"] or 1
		TRID_DB["raidEnteredFrame1"] = TRID_DB["raidEnteredFrame1"] or 1
		TRID_DB["raidKillFrame1"] = TRID_DB["raidKillFrame1"] or 0
		TRID_DB["heroicEnteredFrame1"] = TRID_DB["heroicEnteredFrame1"] or 0
		TRID_DB["heroicKillFrame1"] = TRID_DB["heroicKillFrame1"] or 0
		TRID_DB["zoneFrame1"] = TRID_DB["zoneFrame1"] or 0
		TRID_DB["guildGratsFrame1"] = TRID_DB["guildGratsFrame1"] or 0
	end

	--x and y values to use on the interface options addons tab
	local check_x, check_y, y_space, x1 = 16, -16, 30, 300

	--Create two frames. One for each column
	bnColumnFrame = CreateFrame("Frame", "BNCheckFrame", frame)
	bnColumnFrame:SetAllPoints(frame)
	guildColumnFrame = CreateFrame("Frame", "GuildCheckFrame", frame)
	guildColumnFrame:SetAllPoints(frame)
	guildColumnFrame:SetPoint("TOPLEFT", frame, x1, 0)

	--Title on Interface Options tab
	frame.Title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	frame.Title:SetText("TwitterRealID (TRID)")
	frame.Title:SetPoint("TOPLEFT", check_x, check_y)
	check_y = check_y - 30

	frame.explanationText = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	frame.explanationText:SetText("Select items for TRID to report on")
	frame.explanationText:SetTextColor(1,1,1,1)
	frame.explanationText:SetPoint("TOPLEFT", check_x, check_y)
	check_y = check_y - y_space

	--Set up column headers
	bnColumnFrame.bnColumnTitle = bnColumnFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	bnColumnFrame.bnColumnTitle:SetText("Battle.net")
--~ 	bnColumnFrame.bnColumnTitle:SetTextColor(0,1,1,1)
	bnColumnFrame.bnColumnTitle:SetPoint("TOPLEFT", check_x, check_y)

	guildColumnFrame.guildColumnTitle = guildColumnFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	guildColumnFrame.guildColumnTitle:SetText("Guild")
--~ 	guildColumnFrame.guildColumnTitle:SetTextColor(0,1,1,1)
	guildColumnFrame.guildColumnTitle:SetPoint("TOPLEFT", check_x, check_y)
	check_y = check_y - y_space

	--Set up the check boxes in the interface options tab
	--I really want to rewrite this section and make the code more reusable.  Just getting it up and running for now

	--Loot row
	local lootFrame = TwitterRealID:CreateCheckBox("bnLoot", bnColumnFrame, "Loot", check_x, check_y)
	lootFrame:SetScript("OnClick", function ()
		local state = lootFrame:GetChecked()
		TwitterRealID:ToggleReporting("lootFrame", state)
	end	)
	TwitterRealID:SetupCheckBox("lootFrame", lootFrame)

	local lootFrame1 = TwitterRealID:CreateCheckBox("gLoot", guildColumnFrame, "Loot", check_x, check_y)
	lootFrame1:SetScript("OnClick", function ()
		local state = lootFrame1:GetChecked()
		TwitterRealID:ToggleReporting("lootFrame1", state)
	end	)
	TwitterRealID:SetupCheckBox("lootFrame1", lootFrame1)

	check_y = check_y - y_space

	--Achievements row
	local achievementFrame = TwitterRealID:CreateCheckBox("bnAchievements", bnColumnFrame, "Achievements", check_x, check_y)
	achievementFrame:SetScript("OnClick", function ()
		local state = achievementFrame:GetChecked()
		TwitterRealID:ToggleReporting("achievementFrame", state)
	end	)
	TwitterRealID:SetupCheckBox("achievementFrame", achievementFrame)

	local achievementFrame1 = TwitterRealID:CreateCheckBox("gAchievements", guildColumnFrame, "Achievements", check_x, check_y)
	achievementFrame1:SetScript("OnClick", function ()
		local state = achievementFrame1:GetChecked()
		TwitterRealID:ToggleReporting("achievementFrame", state)
	end	)
	TwitterRealID:SetupCheckBox("achievementFrame1", achievementFrame1)

	check_y = check_y - y_space

	--BG entered row
	local bgEnteredFrame = TwitterRealID:CreateCheckBox("bnBGEntered", bnColumnFrame, "Battlegrounds Entered", check_x, check_y)
	bgEnteredFrame:SetScript("OnClick", function ()
		local state = bgEnteredFrame:GetChecked()
		TwitterRealID:ToggleReporting("bgEnteredFrame", state)
	end	)
	TwitterRealID:SetupCheckBox("bgEnteredFrame", bgEnteredFrame)

	local bgEnteredFrame1 = TwitterRealID:CreateCheckBox("gBGEntered", guildColumnFrame, "Battlegrounds Entered", check_x, check_y)
	bgEnteredFrame1:SetScript("OnClick", function ()
		local state = bgEnteredFrame1:GetChecked()
		TwitterRealID:ToggleReporting("bgEnteredFrame1", state)
	end	)
	TwitterRealID:SetupCheckBox("bgEnteredFrame1", bgEnteredFrame1)

	check_y = check_y - y_space

	--BG won row
	local bgWonFrame = TwitterRealID:CreateCheckBox("bnBGWon", bnColumnFrame, "Battlegrounds Won", check_x, check_y)
	bgWonFrame:SetScript("OnClick", function ()
		local state = bgWonFrame:GetChecked()
		TwitterRealID:ToggleReporting("bgWonFrame", state)
	end	)
	TwitterRealID:SetupCheckBox("bgWonFrame", bgWonFrame)

	local bgWonFrame1 = TwitterRealID:CreateCheckBox("gBGWon", guildColumnFrame, "Battlegrounds Won", check_x, check_y)
	bgWonFrame1:SetScript("OnClick", function ()
		local state = bgWonFrame1:GetChecked()
		TwitterRealID:ToggleReporting("bgWonFrame1", state)
	end	)
	TwitterRealID:SetupCheckBox("bgWonFrame1", bgWonFrame1)

	check_y = check_y - y_space

	--Raids entered row
	local raidEnteredFrame = TwitterRealID:CreateCheckBox("bnRaidEntered", bnColumnFrame, "Raids Entered", check_x, check_y)
	raidEnteredFrame:SetScript("OnClick", function ()
		local state = raidEnteredFrame:GetChecked()
		TwitterRealID:ToggleReporting("raidEnteredFrame", state)
	end	)
	TwitterRealID:SetupCheckBox("raidEnteredFrame", raidEnteredFrame)

	local raidEnteredFrame1 = TwitterRealID:CreateCheckBox("gRaidEntered", guildColumnFrame, "Raids Entered", check_x, check_y)
	raidEnteredFrame1:SetScript("OnClick", function ()
		local state = raidEnteredFrame1:GetChecked()
		TwitterRealID:ToggleReporting("raidEnteredFrame1", state)
	end	)
	TwitterRealID:SetupCheckBox("raidEnteredFrame1", raidEnteredFrame1)

	check_y = check_y - y_space

	--Raid kill row
	local raidKillFrame = TwitterRealID:CreateCheckBox("bnRaidKill", bnColumnFrame, "Raid Kills", check_x, check_y)
	raidKillFrame:SetScript("OnClick", function ()
		local state = raidKillFrame:GetChecked()
		TwitterRealID:ToggleReporting("raidKillFrame", state)
	end	)
	TwitterRealID:SetupCheckBox("raidKillFrame", raidKillFrame)

	local raidKillFrame1 = TwitterRealID:CreateCheckBox("gRaidKill", guildColumnFrame, "Raid Kills", check_x, check_y)
	raidKillFrame1:SetScript("OnClick", function ()
		local state = raidKillFrame1:GetChecked()
		TwitterRealID:ToggleReporting("raidKillFrame1", state)
	end	)
	TwitterRealID:SetupCheckBox("raidKillFrame1", raidKillFrame1)

	check_y = check_y - y_space

	--Heroic entered row
	local heroicEnteredFrame = TwitterRealID:CreateCheckBox("bnHeroicEntered", bnColumnFrame, "Heroics Entered", check_x, check_y)
	heroicEnteredFrame:SetScript("OnClick", function ()
		local state = heroicEnteredFrame:GetChecked()
		TwitterRealID:ToggleReporting("heroicEnteredFrame", state)
	end	)
	TwitterRealID:SetupCheckBox("heroicEnteredFrame", heroicEnteredFrame)

	local heroicEnteredFrame1 = TwitterRealID:CreateCheckBox("gHeroicEntered", guildColumnFrame, "Heroics Entered", check_x, check_y)
	heroicEnteredFrame1:SetScript("OnClick", function ()
		local state = heroicEnteredFrame1:GetChecked()
		TwitterRealID:ToggleReporting("heroicEnteredFrame1", state)
	end	)
	TwitterRealID:SetupCheckBox("heroicEnteredFrame1", heroicEnteredFrame1)

	check_y = check_y - y_space

	--Heroic kill row
	local heroicKillFrame = TwitterRealID:CreateCheckBox("bnHeroicKill", bnColumnFrame, "Heroic Instance Kills", check_x, check_y)
	heroicKillFrame:SetScript("OnClick", function ()
		local state = heroicKillFrame:GetChecked()
		TwitterRealID:ToggleReporting("heroicKillFrame", state)
	end	)
	TwitterRealID:SetupCheckBox("heroicKillFrame", heroicKillFrame)

	local heroicKillFrame1 = TwitterRealID:CreateCheckBox("gHeroicKill", guildColumnFrame, "Heroic Instance Kills", check_x, check_y)
	heroicKillFrame1:SetScript("OnClick", function ()
		local state = heroicKillFrame1:GetChecked()
		TwitterRealID:ToggleReporting("heroicKillFrame1", state)
	end	)
	TwitterRealID:SetupCheckBox("heroicKillFrame1", heroicKillFrame1)

	check_y = check_y - y_space

	--Zone row
	local zoneFrame = TwitterRealID:CreateCheckBox("bnZoneMove", bnColumnFrame, "Zone Movement", check_x, check_y)
	zoneFrame:SetScript("OnClick", function ()
		local state = zoneFrame:GetChecked()
		TwitterRealID:ToggleReporting("zoneFrame", state)
	end	)
	TwitterRealID:SetupCheckBox("zoneFrame", zoneFrame)

	local zoneFrame1 = TwitterRealID:CreateCheckBox("gZoneMove", guildColumnFrame, "Zone Movement", check_x, check_y)
	zoneFrame1:SetScript("OnClick", function ()
		local state = zoneFrame1:GetChecked()
		TwitterRealID:ToggleReporting("zoneFrame1", state)
	end	)
	TwitterRealID:SetupCheckBox("zoneFrame1", zoneFrame1)

	check_y = check_y - y_space

	local guildGratsFrame = TwitterRealID:CreateCheckBox("gAutoGrats", guildColumnFrame, "Auto-Grats Achievements", check_x, check_y)
	guildGratsFrame:SetScript("OnClick", function ()
		local state = guildGratsFrame:GetChecked()
		TwitterRealID:ToggleReporting("guildGratsFrame", state)
	end	)
	TwitterRealID:SetupCheckBox("guildGratsFrame", guildGratsFrame)

	check_y = check_y - y_space

end


---------------------------
--Toggles the status to the passed in variable
---------------------------
function TwitterRealID:Toggle(var)
	TRID_DB.toggleStatus = var
end


---------------------------
--Figures out which message should be displayed and loads it.  In future it will grab custom user messages.
---------------------------
function TwitterRealID:SendCurrentMessage(messageInfo, ...)

	--Name various data with useful names for later manipulation
	local customMessage = ""
	local customGuildMessage = ""
	local name, instanceType, difficulty, difficultyName = GetInstanceInfo()
	local zoneName = GetRealZoneText()
	local bossName, guid = ...
	local achievementName, ap, link = ...
	local itemLink = ...
	local reportLoot = false
	local sender = ...

	--Broadcast control variables. These are toggled on by the various logic checks as applicable. They are toggled off when a broadcast is sent.
	local bnBroadcast = false
	local gBroadcast = false

	--Report loot
	if TRID_DB["lootFrame"] == 1 or TRID_DB["lootFrame1"] == 1 then
		if messageInfo == "loot" then
			if TRID_DB["lootFrame"] == 1 then
				bnBroadcast = true
			end
			if TRID_DB["lootFrame1"] == 1 then
				gBroadcast = true
			end
			--Find the item
			local iName, iLink, iQuality, ilvl, reqLevel, class, subclass, maxStack, equipSlot = GetItemInfo(itemLink)
			--Check the item level
			--Check the item type
			if iQuality == 4 and ilvl >= 359 or iQuality == 5 then
				reportLoot = true
				customMessage = TwitterRealID:LoadMessage(iName, "loot") --Using a link here breaks because it causes the message to be longer than allowed for bnet messages.
				customGuildMessage = TwitterRealID:LoadMessage(iLink, "loot") --set this differently because it can take a link.
				TRID_DB.messageIsInstance = false
			end
		end
	end

	--Report heroic instance entered
	if TRID_DB["heroicEnteredFrame"] == 1 or TRID_DB["heroicEnteredFrame1"] == 1 then
		if instanceType == "party" and messageInfo == "worldState" then
			if TRID_DB["heroicEnteredFrame"] == 1 then
				bnBroadcast = true
			end
			if TRID_DB["heroicEnteredFrame1"] == 1 then
				gBroadcast = true
			end
			local difficulty = GetDungeonDifficulty()
			if difficulty == 2 then
				customMessage = TwitterRealID:LoadMessage(name, "heroic")
				TRID_DB.messageIsInstance = true
			end
		end
	end

	--Report heroic instance entered
	if TRID_DB["raidEnteredFrame"] == 1 or TRID_DB["raidEnteredFrame1"] == 1 then
		if instanceType == "raid" and messageInfo == "worldState" then
			if TRID_DB["raidEnteredFrame"] == 1 then
				bnBroadcast = true
			end
			if TRID_DB["raidEnteredFrame1"] == 1 then
				gBroadcast = true
			end
			customMessage = TwitterRealID:LoadMessage(name, "raid")
			TRID_DB.messageIsInstance = true
		end
	end

	--Report bg entered
	--[[
		Hopefully the check for GetBattlefieldWinner being nil will prevent the scenario where you earn an achievement for winning a bg
		and the bg entered message is broadcast right after it and before the won message.  Seems to be working.
	]]
	if TRID_DB["bgEnteredFrame"] == 1 or TRID_DB["bgEnteredFrame1"] == 1 then
		if instanceType == "pvp" and messageInfo == "worldState" and GetBattlefieldWinner() == nil then
			if TRID_DB["bgEnteredFrame"] == 1 then
				bnBroadcast = true
			end
			if TRID_DB["bgEnteredFrame1"] == 1 then
				gBroadcast = true
			end
			customMessage = TwitterRealID:LoadMessage(name, "bg")
			TRID_DB.messageIsInstance = true
			--tridprint("worldState fired on bg entered check")
		end
	end

	--Report bg won
	if messageInfo == "bgEnd" and instanceType == "pvp" then
		local winner = GetBattlefieldWinner()
		local factionGroup = UnitFactionGroup("player")
		local faction = 0

		if factionGroup == "Alliance" then
			faction = 1
		else
			faction = 0
		end

		if winner == faction then
			if TRID_DB["bgWonFrame"] == 1 or TRID_DB["bgWonFrame1"] == 1 then
				if TRID_DB["bgWonFrame"] == 1 then
					bnBroadcast = true
				end
				if TRID_DB["bgWonFrame1"] == 1 then
					gBroadcast = true
				end
				customMessage = TwitterRealID:LoadMessage(name, "bgWin")
				TRID_DB.currentIsWinMessage = true
				TRID_DB.messageIsInstance = false
			end
		end

		--This clears the message if you lose but not if your current message is a win message.
		--Checking if winner is nil will eliminate this message from firing at any time other than at the actual end of a bg
		if not TRID_DB.currentIsWinMessage and winner ~= faction and instanceType == "pvp" and winner ~= nil then
			customMessage = ""
			messageInfo = "clear"
			TRID_DB.messageIsInstance = false
			TRID_DB.currentIsWinMessage = false
		end
	end

	--Clear instance messages when you leave them as long as you're not dead and zone movement not on.
	--This won't clear the message if they take rez sickness. It's an edge case.
	if instanceType == "none" and TRID_DB.messageIsInstance and not UnitIsDeadOrGhost("player") and TRID_DB["zoneFrame"] ~= 1 then
		customMessage = ""
		messageInfo = "clear"
		TRID_DB.messageIsInstance = false
	end

	--Report achievements
	if TRID_DB["achievementFrame"] == 1 or TRID_DB["achievementFrame1"] == 1 then
		if messageInfo == "achievement" then
			if TRID_DB["achievementFrame"] == 1 then
				bnBroadcast = true
			end
			if TRID_DB["achievementFrame1"] == 1 then
				gBroadcast = true
			end
			customMessage = TwitterRealID:LoadMessage(achievementName, "achievement")

			--ORDER MATTERS HERE. If the BN message is set first, it will cause duplicate data in the guild message.

			--Guild message gets a link but links are too long for BN messages
			customGuildMessage = customMessage..link.." for "..ap.." points"

			--I don't like creating the string here.  Rewrite eventually.
			customMessage = customMessage..achievementName.." for "..ap.." points"
			messageIsInstance = false

		end
	end

	--Auto-grats guild member achievements
	local playerName = UnitName("player")
	if messageInfo == "guildGrats" and TRID_DB["guildGratsFrame"] == 1 and sender ~= playerName then
		--this condition should check to see if it is the same player earning multiple achievements (so we skip the increment and still use their name if it is)
		if doGrats and sender ~= achievementEarner then
			earnerCount = earnerCount + 1
		elseif not doGrats then
			achievementEarner = sender
			earnerCount = 1
			gratsTimer = math.random(5, 9)
			doGrats = true
		end
	end

	--Report raid kills
	if TRID_DB["raidKillFrame"] == 1 or TRID_DB["raidKillFrame1"] == 1 then
		if messageInfo == "bossKill" then
			if TRID_DB["raidKillFrame"] == 1 then
				bnBroadcast = true
			end
			if TRID_DB["raidKillFrame1"] == 1 then
				gBroadcast = true
			end
			local isBoss, fightType, raidBossName = TwitterRealID:VerifyBossNPCByGUID(guid)
			if isBoss and fightType == "raid" then
				customMessage = TwitterRealID:LoadMessage(raidBossName, "kill")
				messageIsInstance = false
			end
		end
	end


	--Report heroic kills
	if TRID_DB["heroicKillFrame"] == 1 or TRID_DB["heroicKillFrame1"] == 1 then
		if messageInfo == "bossKill" then
			if TRID_DB["heroicKillFrame"] == 1 then
				bnBroadcast = true
			end
			if TRID_DB["heroicKillFrame1"] == 1 then
				gBroadcast = true
			end
			local isBoss, fightType, heroicBossName = TwitterRealID:VerifyBossNPCByGUID(guid)
			if isBoss and fightType == "heroic" then
				customMessage = TwitterRealID:LoadMessage(heroicBossName, "kill")
				messageIsInstance = false
			end
		end
	end

	--Report zone movement
	if TRID_DB["zoneFrame"] == 1 or TRID_DB["zoneFrame1"] == 1 then
		if messageInfo == "worldState" and instanceType == "none" then
			if TRID_DB["zoneFrame"] == 1 then
				bnBroadcast = true
			end
			if TRID_DB["zoneFrame1"] == 1 then
				gBroadcast = true
			end
			customMessage = TwitterRealID:LoadMessage(zoneName, "zone")
			messageIsInstance = false
			tridprint("reporting zone movement")
		end
	end


	--Cut down on spam.  This should prevent the addon from sending the same message that is already posted.

	--This checks if the player is dead. It won't fire if a zone change occurs from spawning at a graveyard, for example.
	--if TRID_DB.currentMessage ~= customMessage and customMessage ~= "" and not UnitIsDeadOrGhost("player") then

	--This doesn't check for being dead.  See commented out line above for that check.
	if TRID_DB.currentMessage ~= customMessage and customMessage ~= "" and TRID_DB.toggleStatus then
		TRID_DB.currentMessage = customMessage
		if bnBroadcast == true then
			BNSetCustomMessage(customMessage)
			bnBroadcast = false
		end

		--Send message to guild chat
		if gBroadcast then
			if messageInfo == "achievement" or reportLoot then
				--Set customMessage to customGuildMessage first to record it before appending <TRID>
				customGuildMessage = "<TRID> "..customGuildMessage
				SendChatMessage(customGuildMessage, "GUILD")
			else
				--Append TRID so people know it's an addon not the player
				customGuildMessage = "<TRID> "..customMessage
				SendChatMessage(customGuildMessage, "GUILD")
			end
			gBroadcast = false
		end

		--[[	Need to Normalize the time between realms at some point.
				Will need to do something fancy to figure our their realm time if they are in an instance or bg.
					Maybe track zone time when in zone none and keep rechecking. Logging in to an instance might be problematic.
				Each player will normalize his own times and store realm info to be transmitted with the log.
				Addon will have a realm lookup table for realm times.
				This will be really tough to test in Europe.
				Will also need to handle day transitions
		]]

		local realmTime = TwitterRealID:GetRealmTime()
		--Reset the messageCounter if time has passed since last message. Set TRID_DB.time to new time.
		if realmTime ~= TRID_DB.time then
			TRID_DB.messageCounter = 101
			TRID_DB.time = realmTime
		end

		--Append the counter
		realmTime = realmTime.."."..TRID_DB.messageCounter
		--Increment the counter in case we have two messages within one minute.
		TRID_DB.messageCounter = TRID_DB.messageCounter + 1
		local messageEntry = {[realmTime] = customMessage}

		--Record customMessage to TRID_DB.log and add it to the start of the list.
		table.insert(TRID_DB.log, 1, messageEntry)
		table.insert(TRID_DB_PER_CHAR.log, 1, messageEntry)

		--Refresh the log frame
		TwitterRealID:SetupLog("UPDATE")

		--Just keep track of the last 100 entries.  Remove the oldest ones.
		if #TRID_DB.log > 100 then
			tremove(TRID_DB.log, #TRID_DB.log)
		end
		if #TRID_DB_PER_CHAR.log > 100 then
			tremove(TRID_DB_PER_CHAR.log, #TRID_DB_PER_CHAR.log)
		end

	elseif customMessage == "" and messageInfo == "clear" and TRID_DB.currentMessage ~= "" then
		--Still need to set the string even if it's empty so we can detect whether to play a message when toggling options.
		TRID_DB.currentMessage = customMessage
		BNSetCustomMessage(customMessage)
	end
end


---------------------------
--Returns which message is appropriate for the given zone
---------------------------
function TwitterRealID:LoadMessage(var, varType)
	--grab the message for the passed in var.  check if there is a custom defined message for that zone and if there isn't then use the default. NYI.
	--zoneName = GetRealZoneText()
	local message = ""
	if varType == "boss" then
		message = "Fighting "..var
	elseif varType == "zone" then
		message = "In zone: "..var
	elseif varType == "kill" then
		message = "Just killed "..var
	elseif varType == "bgWin" then
		message = "Won "..var
	elseif varType == "bg" then
		message = "In battleground: "..var
	elseif varType == "achievement" then
		message = "Earned "
	elseif varType == "loot" then
		message = "Won loot: "..var
	elseif varType == "heroic" then
		message = "In heroic: "..var
	elseif varType == "raid" then
		message = "In raid: "..var
	elseif varType == "guildGrats" then
		message = "Grats "..var
	elseif varType == "guildGroupGrats" then
		message = "Grats"
	elseif varType == "setup" then
		message = "Welcome to TRID! Your log will populate with messages as you use this addon. Type /trid to view options"
	end
	return message
end


---------------------------
--Checks TwitterRealIDBossIDs for a known boss
---------------------------
function TwitterRealID:VerifyBossNPCByGUID(npcGUID)
	local npcID = tonumber(npcGUID:sub(7, 10), 16)
	local bossCheck = false
	local bossType = "Not a boss"
	local bossName
	for i, v in pairs (heroicIDTable) do
		if npcID == i and GetDungeonDifficulty() == 2 then
			bossCheck = true
			bossType = "heroic"
			bossName = v
			break
		end
	end
	for i, v in pairs (raidIDTable) do
		if npcID == i then
			bossCheck = true
			bossType = "raid"
			bossName = v
			break
		end
	end
	return bossCheck, bossType, bossName
end


---------------------------
--Sets up the check boxes
---------------------------
function TwitterRealID:CreateCheckBox(boxName, parentName, description, x, y)

	--Create the frame
	local checkFrame = CreateFrame("CheckButton", boxName, parentName, "ChatConfigCheckButtonTemplate")

	--Set the position for the frame within its parent
	checkFrame:SetPoint("TOPLEFT", x, y)

	if description ~= "" then
		getglobal(checkFrame:GetName() .. 'Text'):SetText(description)
	end

	return checkFrame
end


---------------------------
--Handles check box setup
---------------------------
function TwitterRealID:SetupCheckBox(boxName, boxFrame)
	--tridprint(boxName, TRID_DB[boxName], boxFrame)
	if TRID_DB[boxName] == 1 then
		boxFrame:SetChecked(true)
	else
		boxFrame:SetChecked(false)
	end
end


---------------------------
--Handles toggling of reporting
---------------------------
function TwitterRealID:ToggleReporting(category, categoryState)
	TRID_DB[category] = categoryState
	tridprint ("updating "..category.." to "..tostring(categoryState))
end


---------------------------
--Just does the same as the print function but won't print if addon is set to release mode.
---------------------------
function tridprint(...)
	if not release then
		print(...)
	end
end

---------------------------
--OnUpdate function
---------------------------

local function Cycle(self, elapsed)
	--track grats time
	if doGrats then
		gratsTimeElapsed = gratsTimeElapsed + elapsed
		if gratsTimeElapsed >= gratsTime then
			TwitterRealID:GroupGrats()
			doGrats = false
			gratsTimeElapsed = 0
		end
	end
end
local f = CreateFrame("Frame")
f:SetScript("OnUpdate", Cycle)

---------------------------
--Auto Grats grouping.  This messaging is separated out because it must fire from the cycle function after waiting a given amount of time.
---------------------------
function TwitterRealID:GroupGrats()
	local customGuildMessage = ""
	local gratsMessage = ""

	--Only use the person's name if they were the only person who got an achievement within the specified time frame.
	if earnerCount == 1 then
		gratsMessage = TwitterRealID:LoadMessage(achievementEarner, "guildGrats")
	else
		gratsMessage = TwitterRealID:LoadMessage(achievementEarner, "guildGroupGrats")
	end

--~ 	customGuildMessage = "<TRID> "..gratsMessage
	customGuildMessage = gratsMessage
	SendChatMessage(customGuildMessage, "GUILD")

end


--[[ FOR THE FUTURE (ordered by priority)
Battle net grats whisper
Communication of message log between friends
Arena reporting
Option to report bg stats or raid stats.
User sets the message for open world.
When user changes their message, it changes it for open world.
User can change the default messages for zones in the UI.
Allow users to set how much time must pass between message reports.
--]]
